package gregapi.block.metatype;

import static gregapi.data.CS.F;
import static gregapi.data.CS.OPPOSITES;
import static gregapi.data.CS.T;
import gregapi.block.ItemBlockBase;
import gregapi.item.IItemUpdatable;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.world.World;

/**
 * @author Gregorius Techneticies
 */
public class ItemBlockMetaType extends ItemBlockBase implements IItemUpdatable {
	public ItemBlockMetaType(Block aBlock) {
		super(aBlock);
		setMaxDamage(0);
		setHasSubtypes(T);
		setCreativeTab(CreativeTabs.tabBlock);
	}
	
	@Override
	public boolean placeBlockAt(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ, int aMetaData) {
		if (((BlockMetaType)mPlaceable).mBlock == mPlaceable) return aWorld.setBlock(aX, aY, aZ, mPlaceable, aMetaData, 3);
		byte tSide = UT.Code.getSideWrenching((byte)aSide, aHitX, aHitY, aHitZ);
		if (tSide == aSide || tSide == OPPOSITES[aSide]) tSide = OPPOSITES[tSide];
		return aWorld.setBlock(aX, aY, aZ, ((BlockMetaType)mPlaceable).mBlock.mSlabs[tSide], aMetaData, 3);
	}
	
	@Override
	public void updateItemStack(ItemStack aStack) {
		if (((BlockMetaType)mPlaceable).mBlock.mSlabs[1] == mPlaceable || ((BlockMetaType)mPlaceable).mBlock.mSlabs[2] == mPlaceable || ((BlockMetaType)mPlaceable).mBlock.mSlabs[3] == mPlaceable || ((BlockMetaType)mPlaceable).mBlock.mSlabs[4] == mPlaceable || ((BlockMetaType)mPlaceable).mBlock.mSlabs[5] == mPlaceable) {
			UT.Stacks.set(aStack, UT.Stacks.make(((BlockMetaType)mPlaceable).mBlock.mSlabs[0], 1, UT.Stacks.meta(aStack)), F, F);
		}
	}
	
	/* This shit just doesn't want to work.
	
	private boolean mInterrupt = false;
	
	@Override
	public boolean onItemUseFirst(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ) {
		if (aStack.stackSize > 0 && SIDES_VALID[mBlock.mSide]) {
			switch(aSide) {
			case 0: if (aHitY <= 0.01) aY--; break;
			case 1: if (aHitY >= 0.99) aY++; break;
			case 2: if (aHitZ <= 0.01) aZ--; break;
			case 3: if (aHitZ >= 0.99) aZ++; break;
			case 4: if (aHitX <= 0.01) aX--; break;
			case 5: if (aHitX >= 0.99) aX++; break;
			}
			
			Block aBlock = aWorld.getBlock(aX, aY, aZ);
			byte aMetaData = (byte)aWorld.getBlockMetadata(aX, aY, aZ);
			
			if (aBlock instanceof GT_Block_Stones)
			if (aPlayer.canPlayerEdit(aX, aY, aZ, aSide, aStack))
			if (mBlock.mBlock == ((GT_Block_Stones)aBlock).mBlock)
			if (SIDES_VALID[((GT_Block_Stones)aBlock).mSide])
			if (UT.Stacks.equal(aStack, new ItemStack(mBlock.mBlock.mSlabs[0], 1, aMetaData), true))
			if (aWorld.checkNoEntityCollision(mBlock.mBlock.getCollisionBoundingBoxFromPool(aWorld, aX, aY, aZ))) {
				aWorld.setBlock(aX, aY, aZ, mBlock.mBlock, aMetaData, 3);
				aWorld.playSoundEffect(aX+0.5F, aY+0.5F, aZ+0.5F, mBlock.mBlock.stepSound.func_150496_b(), (mBlock.mBlock.stepSound.getVolume() + 1.0F) / 2.0F, mBlock.mBlock.stepSound.getPitch() * 0.8F);
				if (!aPlayer.capabilities.isCreativeMode) aStack.stackSize--;
				mInterrupt = true;
				return false;
			}
		}
		
		return false;
	}
	
	@Override
	public boolean onItemUse(ItemStack aStack, EntityPlayer aPlayer, World aWorld, int aX, int aY, int aZ, int aSide, float aHitX, float aHitY, float aHitZ) {
		if (mInterrupt) {
			mInterrupt = false;
			return false;
		}
		return super.onItemUse(aStack, aPlayer, aWorld, aX, aY, aZ, aSide, aHitX, aHitY, aHitZ);
	}
	*/
}