package gregapi.cover.covers;

import static gregapi.data.CS.F;
import static gregapi.data.CS.PIXELS_NEG;
import static gregapi.data.CS.PIXELS_POS;
import static gregapi.data.CS.T;
import gregapi.cover.CoverData;
import gregapi.data.CS.SFX;
import gregapi.render.BlockTextureDefault;
import gregapi.render.ITexture;
import gregapi.tileentity.connectors.MultiTileEntityWireRedstoneInsulated;
import gregapi.util.UT;
import net.minecraft.entity.Entity;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class CoverRedstoneTorch extends AbstractCoverAttachment {
	@Override public boolean interceptCoverPlacement(byte aCoverSide, CoverData aData, Entity aPlayer) {return !(aData.mTileEntity instanceof MultiTileEntityWireRedstoneInsulated);}
	
	@Override
	public void onTickPost(byte aSide, CoverData aData, long aTimer, boolean aIsServerSide, boolean aReceivedBlockUpdate, boolean aReceivedInventoryUpdate) {
		if (aIsServerSide && aData.mTileEntity instanceof MultiTileEntityWireRedstoneInsulated) {
			if (((MultiTileEntityWireRedstoneInsulated)aData.mTileEntity).connected(aSide)) ((MultiTileEntityWireRedstoneInsulated)aData.mTileEntity).disconnect(aSide, T);
			
			if (((MultiTileEntityWireRedstoneInsulated)aData.mTileEntity).mRedstone > 0) {
				if (aData.mVisuals[aSide] == 0) {
					aData.visual(aSide, (short)1);
					aData.mTileEntity.sendBlockUpdateFromCover();
				}
			} else {
				if (aData.mVisuals[aSide] != 0) {
					aData.visual(aSide, (short)0);
					aData.mTileEntity.sendBlockUpdateFromCover();
				}
			}
		}
	}
	
	@Override
	public void onCoverPlaced(byte aSide, CoverData aData, Entity aPlayer, ItemStack aCover) {
		if (aPlayer != null) UT.Sounds.send(aData.mTileEntity.getWorld(), SFX.MC_DIG_WOOD, 1.0F, -1.0F, aData.mTileEntity.getCoords());
	}
	
	@Override
	public byte getRedstoneOutStrong(byte aCoverSide, CoverData aData, byte aDefaultRedstone) {
		return (byte)(aData.mVisuals[aCoverSide] == 0 ? 15 : 0);
	}
	
	@Override
	public byte getRedstoneOutWeak(byte aCoverSide, CoverData aData, byte aDefaultRedstone) {
		return (byte)(aData.mVisuals[aCoverSide] == 0 ? 15 : 0);
	}
	
	@Override public float[] getCoverBounds(byte aCoverSide, CoverData aData) {return BOXES_TORCHES[aCoverSide];}
	@Override public float[] getHolderBounds(byte aCoverSide, CoverData aData) {return BOXES_TORCHES[aCoverSide];}
	
	public static final float[][] BOXES_TORCHES = new float[][] {{PIXELS_POS[ 7], PIXELS_POS[ 0], PIXELS_POS[ 7], PIXELS_NEG[ 7], PIXELS_NEG[ 8], PIXELS_NEG[ 7]}, {PIXELS_POS[ 7], PIXELS_POS[ 8], PIXELS_POS[ 7], PIXELS_NEG[ 7], PIXELS_NEG[ 0], PIXELS_NEG[ 7]}, {PIXELS_POS[ 7], PIXELS_POS[ 7], PIXELS_POS[ 0], PIXELS_NEG[ 7], PIXELS_NEG[ 7], PIXELS_NEG[ 8]}, {PIXELS_POS[ 7], PIXELS_POS[ 7], PIXELS_POS[ 8], PIXELS_NEG[ 7], PIXELS_NEG[ 7], PIXELS_NEG[ 0]}, {PIXELS_POS[ 0], PIXELS_POS[ 7], PIXELS_POS[ 7], PIXELS_NEG[ 8], PIXELS_NEG[ 7], PIXELS_NEG[ 7]}, {PIXELS_POS[ 8], PIXELS_POS[ 7], PIXELS_POS[ 7], PIXELS_NEG[ 0], PIXELS_NEG[ 7], PIXELS_NEG[ 7]}};
	
	@Override public ITexture getCoverTextureSurface(byte aSide, CoverData aData) {return aData.mVisuals[aSide] == 0 ? sTextureFrontON : sTextureFrontOFF;}
	@Override public ITexture getCoverTextureAttachment(byte aSide, CoverData aData, byte aTextureSide) {return aSide == aTextureSide ? aData.mVisuals[aSide] == 0 ? sTextureFrontON : sTextureFrontOFF : null;}
	@Override public ITexture getCoverTextureHolder(byte aSide, CoverData aData, byte aTextureSide) {return aSide == aTextureSide ? null : aData.mVisuals[aSide] == 0 ? sTextureSideON : sTextureSideOFF;}
	@Override public boolean needsVisualsSaved(byte aSide, CoverData aData) {return T;}
	
	@Override public boolean isSolid(byte aSide, CoverData aData) {return F;}
	
	public static final ITexture
	sTextureFrontON		= BlockTextureDefault.get("machines/covers/redstonetorch/on/front"),
	sTextureSideON		= BlockTextureDefault.get("machines/covers/redstonetorch/on/side"),
	sTextureFrontOFF	= BlockTextureDefault.get("machines/covers/redstonetorch/off/front"),
	sTextureSideOFF		= BlockTextureDefault.get("machines/covers/redstonetorch/off/side");
}